%A MATLAB implementation of
%
%N. Ozay, M. Sznaier, C. Lagoa, O. Camps, "GPCA with Denoising: A
%Moments-Based Convex Approach", CVPR 2010.
%
%Author: Necmiye Ozay <necmiye@coe.neu.edu>
%
%Northeastern University, Boston. September 2009.
%
%Notice: The packages should NOT be used for any commercial purposes
%without direct consent of their author(s). The authors are not responsible
%for any potential property loss or damage caused directly or indirectly by
%the usage of the software.

function Jp = perspective_derivative(c,powers,x1,x2)

powers = powers(:,1:end-1);
[num_pow K] = size(powers);

index = find(abs(x1) < 1e-10);
x1(index) = 1e-10;
index = find(abs(x2) < 1e-10);
x2(index) = 1e-10;
logX = log([x1;x2]);

Dc = (c*ones(1,K)).* powers; 


for i=1:K
    dummy = zeros(1,K);
    dummy(i)=1;
    powers2 = powers - ones(num_pow,1)*dummy;
    ind = find(powers(:,i)>0);
    y = exp(powers2(ind,:)*logX);
    y = real(y);
    Jp(i,:) = Dc(ind,i)'*y;
end
