%A MATLAB implementation of
%
%N. Ozay, M. Sznaier, C. Lagoa, O. Camps, "GPCA with Denoising: A
%Moments-Based Convex Approach", CVPR 2010.
%
%Author: Necmiye Ozay <necmiye@coe.neu.edu>
%
%Northeastern University, Boston. September 2009.
%
%Notice: The packages should NOT be used for any commercial purposes
%without direct consent of their author(s). The authors are not responsible
%for any potential property loss or damage caused directly or indirectly by
%the usage of the software.

function [y,powers] = perspective_veronese(x1,x2,n)

if mod(n,2)==1
  error('Degree of perspective veronese should be even');
else
  [K,N] = size(x1);
  powers = perspectiveExponent(2*K,n);
  powers = [powers,2*K-sum(powers,2)];
  index = find(abs(x1) < 1e-10);
  x1(index) = 1e-10;
  index = find(abs(x2) < 1e-10);
  x2(index) = 1e-10;
  y = exp(powers*log([x1;x2;ones(1,N)]));
end

y = real(y);