%S. Rao, A. Y. Yang, A. Wagner, and Y. Ma. Segmentation
%of hybrid motions via hybrid quadratic surface analysis. In
%ICCV 2005.

%Implemented by NO, Sep 2009.
%For comparison on the teapot example.

clear all;
close all;

init_spectral;

load teapot2;

num_pnts = size(img1,2);

[y,powers] = perspective_veronese(img1,img2,2*num_object);

[u d v] = svd(y);

c = u(:,end);

Jp = perspective_derivative(c,powers,img1,img2);

Hp = perspective_hessian(c,powers,img1,img2);

simMat = zeros(num_pnts);
for i=1:num_pnts
    for j=i+1:num_pnts
        t12 = null([Jp(:,j)';Jp(:,i)']);
        c12 = t12'*Hp(:,:,i)*t12;
        c21 = t12'*Hp(:,:,j)*t12;
        simMat(i,j) = subspace(c12(:),c21(:));
    end
end
simMat = simMat+simMat';
res=njw_anchor(-simMat,2);

figure;plot(res,'b.'); title('HQSA Result');
figure;plot(res_true,'r.'); title('Groundtruth Segmentation');
